#import "/src/cetz.typ": draw

#import "/src/core/utils.typ": normalize-measure
#import "/src/consts.typ": *

#let name = "actor"

#let render(x, y, p, bottom) = {
  let m = measure(p.display-name)
  let style = p.resolved-style
  let w2 = ACTOR-WIDTH / 2
  let head-r = ACTOR-WIDTH / 4
  let height = ACTOR-WIDTH * 2
  let arms-y = height * 0.375

  let y0 = if bottom {
    y - m.height / 1pt - SYM-GAP
  } else {
    y + m.height / 1pt + height + SYM-GAP
  }
  draw.circle(
    (x, y0 - head-r),
    radius: head-r,
    fill: style.fill,
    stroke: style.stroke
  )
  draw.line((x, y0 - head-r * 2), (x, y0 - height + w2), stroke: black + .5pt)
  draw.line((x - w2, y0 - arms-y), (x + w2, y0 - arms-y), stroke: black + .5pt)
  draw.line((x - w2, y0 - height), (x, y0 - height + w2), (x + w2, y0 - height), stroke: black + .5pt)
  draw.content(
    (x, y),
    p.display-name,
    anchor: if bottom {"north"} else {"base"}
  )
}

#let get-size(par) = {
  let m = normalize-measure(par.display-name)

  //ACTOR-WIDTH * 1pt
  //ACTOR-WIDTH * 2pt + SYM-GAP * 1pt + h

  return m
}

#let default-style = (
  :
)